"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Expression(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import opencb as opencb_2_9_3

        return {
            "expression": opencb_2_9_3.ExpressionCall,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.avro.ExpressionCall": opencb_2_9_3.ExpressionCall,
            "org.opencb.biodata.models.variant.avro.Expression": opencb_2_9_3.Expression,
        }

    __slots__ = [
        "experimentId",
        "experimentalFactor",
        "expression",
        "factorValue",
        "geneName",
        "pvalue",
        "technologyPlatform",
        "transcriptId",
    ]

    def __init__(
        self,
        experimentId=None,
        experimentalFactor=None,
        expression=None,
        factorValue=None,
        geneName=None,
        pvalue=None,
        technologyPlatform=None,
        transcriptId=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.Expression model.

        :param experimentId:
        :type experimentId: None | str
        :param experimentalFactor:
        :type experimentalFactor: None | str
        :param expression:
        :type expression: None | ExpressionCall
        :param factorValue:
        :type factorValue: None | str
        :param geneName:
        :type geneName: None | str
        :param pvalue:
        :type pvalue: None | float
        :param technologyPlatform:
        :type technologyPlatform: None | str
        :param transcriptId:
        :type transcriptId: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
